Index: TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/AnnotationManager.java
===================================================================
--- TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/AnnotationManager.java	(revision 3421)
+++ TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/AnnotationManager.java	(revision 3422)
@@ -1,22 +1,39 @@
 package org.txm.annotation.kr.core;
 
 import java.io.File;
+import java.io.IOException;
+import java.io.PrintWriter;
+import java.nio.charset.Charset;
 import java.util.ArrayList;
 import java.util.Arrays;
+import java.util.Comparator;
 import java.util.HashMap;
 import java.util.List;
 
+import org.apache.commons.lang.StringUtils;
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.osgi.util.NLS;
+import org.osgi.service.prefs.BackingStoreException;
 import org.txm.annotation.kr.core.messages.KRAnnotationCoreMessages;
 import org.txm.annotation.kr.core.repository.AnnotationEffect;
 import org.txm.annotation.kr.core.repository.AnnotationType;
+import org.txm.annotation.kr.core.repository.KnowledgeRepository;
 import org.txm.annotation.kr.core.repository.TypedValue;
 import org.txm.annotation.kr.core.storage.temporary.TemporaryAnnotationManager;
+import org.txm.core.preferences.TBXPreferences;
+import org.txm.core.preferences.TXMPreferences;
 import org.txm.objects.Match;
 import org.txm.objects.Match2P;
+import org.txm.searchengine.cqp.AbstractCqiClient;
+import org.txm.searchengine.cqp.CQPSearchEngine;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
+import org.txm.searchengine.cqp.corpus.QueryResult;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
+import org.txm.searchengine.cqp.serverException.CqiServerError;
 import org.txm.utils.ConsoleProgressBar;
+import org.txm.utils.CsvReader;
+import org.txm.utils.io.IOUtils;
 import org.txm.utils.logger.Log;
 
 /**
@@ -286,7 +303,7 @@
 							i--;
 						}
 						else if (!a.getType().equals(annotSelectedType.getId()) && (// different type and inner or outer wrap
-						(a.getStart() <= start && end <= a.getEnd()) ||
+								(a.getStart() <= start && end <= a.getEnd()) ||
 								(start <= a.getStart() && a.getEnd() <= end))) {
 							cqpAnnotations.remove(i);
 							i--;
@@ -396,4 +413,206 @@
 	public boolean isDirty() {
 		return dirty;
 	}
+	
+	public boolean exportAnnotationsToTable(File resultFile) throws Exception {
+		
+		final String encoding = TBXPreferences.getInstance().getString(TBXPreferences.EXPORT_ENCODING);
+		String colseparator = TBXPreferences.getInstance().getString(TBXPreferences.EXPORT_COL_SEPARATOR);
+		String txtseparator = TBXPreferences.getInstance().getString(TBXPreferences.EXPORT_TXT_SEPARATOR);
+		
+		List<String> krnames = KRAnnotationEngine.getKnowledgeRepositoryNames(corpus);
+		if (krnames.size() == 0) {
+			Log.severe(NLS.bind("** Error: no knowledge repository found in {0} corpus.", corpus));
+			throw new IllegalArgumentException("No kr in " + corpus);
+		}
+		String firtsKRName = krnames.get(0);
+		KnowledgeRepository defaultKR = KRAnnotationEngine.getKnowledgeRepository(corpus, firtsKRName);
+		if (defaultKR == null) {
+			Log.severe(NLS.bind("** Error: no knowledge repository {0} found in {0} corpus.", defaultKR, corpus));
+			throw new IllegalArgumentException("No kr " + defaultKR + " in " + corpus);
+		}
+		
+		PrintWriter writer = IOUtils.getWriter(resultFile, encoding, false);
+		String cols [] = {"text_id", "id", "end_id", "start", "end", "type", "value", "mode", "date", "annotator"};
+		writer.println(StringUtils.join(cols, colseparator));
+		
+		if (this.getTemporaryManager().getAnnotations().size() == 0) {
+			Log.warning("Warning: no annotations to export. Aborting.");
+			return false;
+		}
+		
+		String[] textsIds = corpus.getCorpusTextIdsList();
+		int[] textsEndPositions = corpus.getTextEndLimits();
+		
+		HashMap<Integer, String> positions2Ids = new HashMap<Integer, String>();
+		HashMap<Integer, String> positions2TextIds = new HashMap<Integer, String>();
+		for (Annotation a : this.getTemporaryManager().getAnnotations()) {
+			positions2Ids.put(a.getStart(), null);
+			positions2Ids.put(a.getEnd(), null);
+		}
+		int[] positions = new int[positions2Ids.keySet().size()];
+		int i = 0;
+		for (int p : positions2Ids.keySet()) {
+			positions[i++] = p;
+		}
+		String values[] = corpus.getProperty("id").cpos2Str(positions);
+		for (i = 0 ; i < positions.length ; i++) {
+			positions2Ids.put(positions[i], values[i]);
+		}
+		
+		List<Annotation> annotations = this.getTemporaryManager().getAnnotations();
+		annotations.sort(new Comparator<Annotation>() {
+			@Override
+			public int compare(Annotation arg0, Annotation arg1) {
+				return arg0.getStart() - arg1.getStart();
+			}
+		});
+		
+		Log.info(NLS.bind("Exporting {0} annotations.", annotations.size()));
+		ConsoleProgressBar cpb = new ConsoleProgressBar(annotations.size());
+		
+		int currentText = 0;
+		for (Annotation a : annotations) {
+			cpb.tick();
+			// text_id	id	start	end	type	value	effect	date	annotator
+			String effect = defaultKR.getType(a.getType()).getEffect().name();
+			String startId = positions2Ids.get(a.getStart());
+			String endId = positions2Ids.get(a.getEnd());
+
+			while (textsEndPositions[currentText] < a.getStart()) {
+				// System.out.println("currentText="+currentText+" a="+a.getStart()+" text start="+textsEndPositions[currentText]+" text id="+textsIds[currentText]);
+				currentText++;// go to next text
+			}
+			String textid = textsIds[currentText];
+			
+			writer.println(
+					txtseparator+textid.replace(txtseparator, txtseparator+txtseparator)				+txtseparator
+					+colseparator+txtseparator+startId.replace(txtseparator, txtseparator+txtseparator)				+txtseparator
+					+colseparator+txtseparator+endId.replace(txtseparator, txtseparator+txtseparator)				+txtseparator
+					+colseparator+txtseparator+a.getStart()															+txtseparator
+					+colseparator+txtseparator+a.getEnd()															+txtseparator
+					+colseparator+txtseparator+a.getType().replace(txtseparator, txtseparator+txtseparator)			+txtseparator
+					+colseparator+txtseparator+a.getValue().replace(txtseparator, txtseparator+txtseparator)		+txtseparator
+					+colseparator+txtseparator+effect.replace(txtseparator, txtseparator+txtseparator)				+txtseparator
+					+colseparator+txtseparator+a.getDate().replace(txtseparator, txtseparator+txtseparator)			+txtseparator
+					+colseparator+txtseparator+a.getAnnotator().replace(txtseparator, txtseparator+txtseparator)	+txtseparator);
+		}
+		writer.close();
+		cpb.done();
+		return true;
+	}
+
+	public boolean importAnnotationsFromTable(File annotationsFile) throws Exception {
+		
+		if (!isOpen()) {
+			this.initialize();
+		}
+		
+		final String encoding = TBXPreferences.getInstance().getString(TBXPreferences.EXPORT_ENCODING);
+		String colseparator = TBXPreferences.getInstance().getString(TBXPreferences.EXPORT_COL_SEPARATOR);
+		String txtseparator = TBXPreferences.getInstance().getString(TBXPreferences.EXPORT_TXT_SEPARATOR);
+		
+		List<String> krnames = KRAnnotationEngine.getKnowledgeRepositoryNames(corpus);
+		if (krnames.size() == 0) {
+			Log.severe(NLS.bind("** Error: no knowledge repository found in {0} corpus.", corpus));
+			throw new IllegalArgumentException("No kr in " + corpus);
+		}
+		String firtsKRName = krnames.get(0);
+		KnowledgeRepository defaultKR = KRAnnotationEngine.getKnowledgeRepository(corpus, firtsKRName);
+		if (defaultKR == null) {
+			Log.severe(NLS.bind("** Error: no knowledge repository {0} found in {0} corpus.", defaultKR, corpus));
+			throw new IllegalArgumentException("No kr " + defaultKR + " in " + corpus);
+		}
+		
+		CsvReader reader = new CsvReader(annotationsFile.getAbsolutePath(), colseparator.charAt(0), Charset.forName(encoding));
+		if (txtseparator.length() > 0) reader.setTextQualifier(txtseparator.charAt(0));
+		reader.readHeaders();
+		String headers [] = reader.getHeaders();
+		String cols [] = {"text_id", "id", "end_id", "start", "end", "type", "value", "mode", "date", "annotator"};
+		if (headers.length != cols.length) {
+			Log.warning("Error: annotation file header format is not well-formatted: "+StringUtils.join(headers, ", ")+". Should be: "+StringUtils.join(cols, ", "));
+			return false;
+		}
+		for (int i = 0 ; i < cols.length ; i++) {
+			if (!(headers[i].equals(cols[i]))) {
+				Log.warning("Error: annotation file header format is not well-formatted: "+StringUtils.join(headers, ", ")+". Should be: "+StringUtils.join(cols, ", "));
+				return false;
+			}
+		}
+		
+		int nLines = 0;
+		while (reader.readRecord()) {
+			nLines++;
+		}
+		reader.close();
+		
+		if (nLines == 0) {
+			Log.warning("Error: no annotation line found");
+			return false;
+		}
+		
+		Log.info(NLS.bind("Importing {0} annotations...", nLines));
+		reader = new CsvReader(annotationsFile.getAbsolutePath(), colseparator.charAt(0), Charset.forName(encoding));
+		if (txtseparator.length() > 0) reader.setTextQualifier(txtseparator.charAt(0));
+		reader.readHeaders();
+		ConsoleProgressBar cpb = new ConsoleProgressBar(nLines);
+		this.tempManager.getEntityManager().getTransaction().begin();
+		while (reader.readRecord()) {
+			cpb.tick();
+			String[] record = reader.getValues();
+			String typeName = record[5].trim();
+			String typeEffect = record[7].trim();
+			if (defaultKR.getType(typeName) == null) {
+				defaultKR.addType(typeName, typeName, null, AnnotationEffect.valueOf(typeEffect));
+			}
+			AnnotationType type = defaultKR.getType(typeName);
+			String startId = record[1].trim();
+			String endId = record[2].trim();
+			int startPos = -1;
+			int endPos = -1;
+			if (startId.length() > 0 && endId.length() > 0) { // use the word id if present
+				String textId = record[0].trim();
+				if (startId.equals(endId)) {
+					CQLQuery cql = new CQLQuery(NLS.bind("[id=\"{0}\" & _.text_id=\"{1}\"]", startId, textId));
+					QueryResult qr = corpus.query(cql , "TMP", false);
+					if (qr.getNMatch() == 0) {
+						Log.warning("No match found with CQL="+cql);
+						continue;
+					}
+					startPos = qr.getMatch(0).getStart();
+					endPos = startPos;
+				} else {
+					CQLQuery cql = new CQLQuery(NLS.bind("[id=\"{0}\" & _.text_id=\"{1}\"]", startId, textId));
+					QueryResult qr = corpus.query(cql , "TMP", false);
+					if (qr.getNMatch() == 0) {
+						Log.warning("No match found with CQL="+cql);
+						continue;
+					}
+					startPos = qr.getMatch(0).getStart();
+					qr.drop();
+					cql = new CQLQuery(NLS.bind("[id=\"{0}\" & _.text_id=\"{1}\"]", endId, textId));
+					qr = corpus.query(cql , "TMP", false);
+					if (qr.getNMatch() == 0) {
+						Log.warning("No match found with CQL="+cql);
+						continue;
+					}
+					endPos = qr.getMatch(0).getStart();
+					qr.drop();
+				}
+			} else {
+				startPos = Integer.parseInt(record[3]);
+				endPos = Integer.parseInt(record[4]);
+				
+			}
+			if (type.getTypedValue(record[6]) == null) {
+				defaultKR.addValue(record[6], record[6], typeName);
+			}
+			TypedValue value = type.getTypedValue(record[6]);
+			List<Annotation> a = this.tempManager.createAnnotationNoCommit(type, value, startPos, endPos);
+		}
+		this.tempManager.getEntityManager().getTransaction().commit();
+		cpb.done();
+		
+		return true;
+	}
 }
Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/annotation/ImportWordPropertiesFromTableMacro.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/annotation/ImportWordPropertiesFromTableMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/annotation/ImportWordPropertiesFromTableMacro.groovy	(revision 3422)
@@ -0,0 +1,105 @@
+package org.txm.macro.annotation;
+
+import org.txm.utils.*
+import org.txm.utils.io.*
+
+import java.nio.charset.Charset
+
+import org.kohsuke.args4j.*
+
+import groovy.transform.Field
+
+import org.txm.rcp.swt.widget.parameters.*
+
+@Field @Option(name="inputDirectory", usage="The XML-TXM folder", widget="Folder", required=true, def="")
+def inputDirectory = new File(System.getProperty("user.home"), "xml/anapovoas/HELPTXM-02-131124/ite02")
+
+@Field @Option(name="outputDirectory", usage="The result folder", widget="Folder", required=true, def="")
+def outputDirectory = new File(System.getProperty("user.home"), "xml/anapovoas/HELPTXM-02-131124/ite03")
+
+@Field @Option(name="tsvFile", usage="The annotation TSV file", widget="File", required=true, def="")
+def tsvFile = new File(System.getProperty("user.home"), "xml/anapovoas/HELPTXM-02-131124/TSV-ITE02.csv")
+
+@Field @Option(name="properties", usage="columns to inject separated by commas", widget="String", required=true, def="p1, p2, ... , pn")
+def properties = "verificado"
+
+@Field @Option(name="debug", usage="Debug de the macro", widget="Boolean", required=true, def="false")
+def debug = true
+
+if (!ParametersDialog.open(this)) return;
+
+def split = properties.split(",")
+if (split.length == 0) {
+	println "ERROR: no property given"
+	return false
+}
+properties = []
+for (def p : split) properties << p.trim()
+
+println "Injecting annotations with the following parameters:"
+println "- inputDirectory: $inputDirectory"
+println "- outputDirectory: $outputDirectory"
+println "- tsvFile: $tsvFile"
+println "- properties: $properties"
+
+outputDirectory.mkdir()
+if (!outputDirectory.exists()) {
+	println "ERROR: could not create or read $outputDirectory directory"
+	return false
+}
+
+CsvReader records = new CsvReader(tsvFile.getAbsolutePath(), "\t".charAt(0), Charset.forName("UTF-8"))
+records.setTextQualifier((char)0)
+records.readHeaders();
+
+def header = Arrays.asList(records.getHeaders())
+if (debug) println "CSV header: $header"
+for (def s : properties) if (!header.contains(s)) {
+	println "Missing annotation property : $s"
+	return;
+}
+for (def s : ["text_id", "id"]) if (!header.contains(s)) {
+	println "Missing annotation property : $s"
+	return;
+}
+
+def injections = [:]
+int no = 1;
+while (records.readRecord()) {
+	String textid = records.get("text_id")
+	if (!injections.containsKey(textid)) injections[textid] = [:]
+	
+	def props = [:]
+	for (def s : properties) props[s] = records.get(s)
+	if (records.get("id") == "") {
+		 print "ERROR in record "+no
+	} else {
+		injections[textid][records.get("id")] = props
+	}
+	no++;
+}
+
+println "Injecting..."
+//for (String textid : injections.keySet()) {
+for (File currentXMLFile : inputDirectory.listFiles().sort{ it.name }) {
+	if (currentXMLFile.isDirectory()) continue;
+	if (currentXMLFile.isHidden()) continue;
+	
+	String textid = currentXMLFile.getName();
+	int idx = textid.lastIndexOf(".")
+	if (idx > 0) textid = textid.substring(0, idx);
+	
+	if (injections.containsKey(textid)) {	
+		if (debug) println "Injections of "+injections[textid].size()+" lines."
+		
+		def builder = new AnnotationInjectionFilter(currentXMLFile, injections[textid], properties, debug)
+		println "injecting in $currentXMLFile $properties"
+		builder.process(new File(outputDirectory, currentXMLFile.getName()));
+		println ""+builder.n+" lines injected."
+	} else {
+		println "copying file $currentXMLFile"
+		FileCopy.copy(currentXMLFile, new File(outputDirectory, currentXMLFile.getName()))
+	}
+}
+
+println "New XML-TXM files are saved in ${outputDirectory}."
\ No newline at end of file
Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/annotation/ExportWordPropertiesToTableMacro.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/annotation/ExportWordPropertiesToTableMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/annotation/ExportWordPropertiesToTableMacro.groovy	(revision 3422)
@@ -0,0 +1,187 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+//
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+//
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+//
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+//
+//
+// $LastChangedDate: 2012-10-15 17:35:36 +0200 (lun., 15 oct. 2012) $
+// $LastChangedRevision: 2279 $
+// $LastChangedBy: mdecorde $
+//
+package org.txm.macro.annotation
+
+import org.txm.Toolbox
+import org.txm.searchengine.cqp.corpus.*
+import org.txm.searchengine.cqp.corpus.query.*
+import org.txm.concordance.core.functions.Concordance
+import org.txm.concordance.core.functions.Line
+import org.txm.functions.concordances.*
+import org.txm.functions.concordances.comparators.*
+import org.txm.searchengine.cqp.ReferencePattern
+
+import java.util.List
+
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.rcp.swt.widget.parameters.*
+
+if (!(corpusViewSelection instanceof CQPCorpus)) {
+	println "Error: you must select a corpus or a subcorpus to export properties"
+	return false;
+}
+
+CQPCorpus corpus = corpusViewSelection
+
+
+@Field @Option(name="properties", usage="columns to inject separated by commas", widget="String", required=true, def="p1, p2, ... , pn")
+		def properties = "pos"
+
+@Field @Option(name="query", usage="The query to select words to annotate", widget="Query", required=true, def="[]")
+		def query
+
+@Field @Option(name="leftcontextsize", usage="The context sizes", widget="Integer", required=true, def="10")
+		def leftcontextsize = 10
+
+@Field @Option(name="rightcontextsize", usage="The context sizes", widget="Integer", required=true, def="10")
+		def rightcontextsize = 10
+
+@Field @Option(name="references", usage="references to show", widget="String", required=true, def="text_id")
+		def references = "text_id, p_id, s_id"
+
+@Field @Option(name="tsvFile", usage="The result TSV file", widget="File", required=true, def="export.tsv")
+		def tsvFile
+
+if (!ParametersDialog.open(this)) return;
+
+def split = properties.split(",")
+if (split.length == 0) {
+	println "ERROR: no property given"
+	return false
+}
+properties = []
+for (def p : split) properties << p.trim()
+
+println "Building Annotation Table with the following parameters: "
+println "- corpus: $corpus"
+println "- query: $query"
+println "- annotation properties: $properties"
+println "- TSV file: $tsvFile"
+
+tsvFile = tsvFile.getAbsoluteFile()
+if (!tsvFile.getParentFile().canWrite()) {
+	println "Error: "+tsvFile.getParentFile()+" is not writable."
+	return;
+}
+
+def annots = []
+for (def p : properties) {
+	def prop = corpus.getProperty(p)
+	if (prop == null) {
+		println "No such property $p in the $corpus corpus"
+		return false;
+	}
+	annots << prop
+}
+def id = corpus.getProperty("id")
+def word = corpus.getProperty("word")
+def text = corpus.getStructuralUnit("text")
+def text_id = text.getProperty("id")
+def refs = references.split(",")
+
+if (annots == null || annots.size() == 0) {
+	println "No such property given"//$annots in the $corpus corpus"
+	return false;
+}
+
+println "Exporting ..."
+def start = System.currentTimeMillis()
+
+// define the references pattern for each concordance line
+def referencePattern = new ReferencePattern()
+referencePattern.addProperty(text_id)
+referencePattern.addProperty(id)
+for (def annot : annots) referencePattern.addProperty(annot)
+
+def refProperties = []
+for (def ref : refs) {
+	ref = ref.trim()
+	try {
+		if (ref.contains("_")) {
+			def split2 = ref.split("_",2)
+			def refp = corpus.getStructuralUnit(split2[0].trim()).getProperty(split2[1].trim())
+			if (ref != "text_id")
+				referencePattern.addProperty(refp)
+			refProperties << refp
+		} else {
+			def p = corpus.getProperty(ref)
+			if (p != null) referencePattern.addProperty(p)
+		}
+	} catch(Exception e) { println "Error while parsing references: "+ref+" "+e}
+}
+
+// compute the concordance with contexts of 15 words on each side of the keyword
+//query = new Query(Query.fixQuery(query))
+def viewprops = [word]
+viewprops.addAll(annots)
+Concordance concordance = new Concordance(corpus)
+concordance.setParameters(query, [word], [word], [word], viewprops, viewprops, viewprops, referencePattern, referencePattern, leftcontextsize, rightcontextsize)
+concordance.compute()
+//println "Conc done "+(System.currentTimeMillis()-start)
+
+def writer = tsvFile.newWriter("UTF-8");
+
+//println "Writing lines..."
+start = System.currentTimeMillis()
+String annotHeader = ""
+for (def annot : annots) annotHeader += "\t$annot"
+writer.write("N"+"\t"+"Références"+"\t"+"ContexteGauche"+"\t"+"Pivot"+annotHeader+"\t"+"ContexteDroit"+"\t"+"id"+"\t"+"text_id\n")
+
+// define which occurrence properties will be displayed
+concordance.setViewProperties([word])
+int NLines = concordance.getNLines();
+int chunk = 1000;
+for (int i = 0 ; i < concordance.getNLines() ; i += chunk) {
+	List<Line> lines
+	if (i+chunk > NLines)
+		lines = concordance.getLines(i, concordance.getNLines()-1)
+	else
+		lines = concordance.getLines(i, i+chunk-1) // e.g. from 0 to 999
+
+	int n = 1
+	for (Line l : lines) {
+		String ntext = l.getViewRef().getValue(text_id)
+		String lcontext = l.leftContextToString()
+		String pivot = l.keywordToString()
+		String rcontext = l.rightContextToString()
+		String ids = l.getViewRef().getValue(id)
+		String refValue = "";
+		for (def refp : refProperties) refValue += " "+l.getViewRef().getValue(refp)
+
+		String poss = "";
+		for (def annot : annots) {
+			poss += "\t"+l.getViewRef().getValue(annot)
+		}
+
+		//println l.getKeywordsViewProperties().get(pos)
+		writer.write(""+(l.getKeywordPosition())+"\t"+refValue+"\t"+lcontext+"\t"+pivot+poss+"\t"+rcontext+"\t"+ids+"\t"+ntext+"\n")
+	}
+	writer.flush()
+}
+println "Saved in "+tsvFile.getAbsolutePath()
+writer.close()
\ No newline at end of file
Index: TXM/trunk/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java
===================================================================
--- TXM/trunk/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java	(revision 3421)
+++ TXM/trunk/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java	(revision 3422)
@@ -41,6 +41,7 @@
 import org.txm.objects.Project;
 import org.txm.objects.Text;
 import org.txm.rcp.StatusLine;
+import org.txm.rcp.commands.ShowSelected;
 import org.txm.rcp.editors.CommandLink;
 import org.txm.rcp.utils.IOClipboard;
 import org.txm.rcp.utils.URLUtils;
@@ -295,7 +296,7 @@
 		try {
 			return getBrowser().execute(code);
 		}
-		catch (Exception e) {
+		catch (Throwable e) {
 			Log.severe("Browser execute error: " + e);
 			Log.printStackTrace(e);
 		}
@@ -552,15 +553,17 @@
 				if (focusedWordID != null) {
 					// System.out.println("Focus on: "+focusedWordID);
 					String s = "try { showElementIfNeeded(document.getElementById(\"" + focusedWordID + "\")); } catch (e) {document.getElementById(\"" + focusedWordID + "\").scrollIntoView();};"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+					//String s = "document.getElementById(\"" + focusedWordID + "\").scrollIntoView();"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 					buffer.append(s + "\n"); //$NON-NLS-1$
 				}
 				
 				if (buffer.length() > 0) {
+				//Object rez2 = execute(buffer.toString());
 					if (execute(buffer.toString())) {
 						focusedWordID = null; // focus one time
 					}
 					else {
-						Log.fine("JS execution (focus) error with=" + buffer);
+						Log.fine("JS execution (focus) error with script=" + buffer);
 					}
 				}
 				
@@ -782,6 +785,8 @@
 			if (currentPage == null || !openedPage.equals(currentPage)) {
 				this.showPage(openedPage);
 				return true;
+			} else {
+				updateWordStyles(); // no need to change the page, but still update the focus&styles
 			}
 		}
 		
@@ -1395,6 +1400,20 @@
 					@Override
 					public void widgetDefaultSelected(SelectionEvent e) {}
 				});
+				
+				MenuItem propertiesItem = new MenuItem(menu, SWT.NONE);
+				propertiesItem.setText("Properties");
+				propertiesItem.addSelectionListener(new SelectionListener() {
+					
+					@Override
+					public void widgetSelected(SelectionEvent e) {
+						
+						ShowSelected.print(new File(getURL()));
+					}
+					
+					@Override
+					public void widgetDefaultSelected(SelectionEvent e) {}
+				});
 			}
 			
 			@Override
Index: TXM/trunk/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditionEditor.java
===================================================================
--- TXM/trunk/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditionEditor.java	(revision 3421)
+++ TXM/trunk/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditionEditor.java	(revision 3422)
@@ -999,13 +999,14 @@
 	public boolean backToText(Text text, String line_wordid) {
 		try {
 			text.compute();
-			this.setText(text, false);
+			//this.setText(text, false); // not necesasry if panel.backtotext is called after
 			
 			for (EditionPanel p : editionPanels.values()) {
 				p.backToText(text, line_wordid);
 			}
 			updatePageLabel();
-			updateWordStyles();
+			
+			//updateWordStyles();
 			notifyExtensions("onBackToText"); //$NON-NLS-1$
 			return true;
 		}
Index: TXM/trunk/org.txm.edition.rcp/res/js/functions.js
===================================================================
--- TXM/trunk/org.txm.edition.rcp/res/js/functions.js	(revision 3421)
+++ TXM/trunk/org.txm.edition.rcp/res/js/functions.js	(revision 3422)
@@ -11,6 +11,7 @@
 		return null;
 }
 txmGetParent = function txmGetParent(node) {
+	if (node == null) return;
 	if (typeof node.parentNode != 'undefined')
 		return node.parentNode;
 	else
@@ -186,6 +187,7 @@
 // }
 
 showElementIfNeeded = function showElementIfNeeded(el) {
+	if (el == null) return;
 	if (!Element.prototype.scrollIntoViewIfNeeded) {
 		if (!isAnyPartOfElementInViewport(el))
 			el.scrollIntoView(false);
@@ -196,6 +198,7 @@
 
 isAnyPartOfElementInViewport = function isAnyPartOfElementInViewport(el) {
 	try {
+		if (el == null) return false;
 		const rect = el.getBoundingClientRect();
 		// DOMRect { x: 8, y: 8, width: 100, height: 100, top: 8, right: 108,
 		// bottom: 108, left: 8 }
@@ -203,10 +206,8 @@
 		const windowWidth = (window.innerWidth || document.documentElement.clientWidth);
 
 		// http://stackoverflow.com/questions/325933/determine-whether-two-date-ranges-overlap
-		const vertInView = (rect.top <= windowHeight)
-				&& ((rect.top + rect.height) >= 0);
-		const horInView = (rect.left <= windowWidth)
-				&& ((rect.left + rect.width) >= 0);
+		const vertInView = (rect.top <= windowHeight) && ((rect.top + rect.height) >= 0);
+		const horInView = (rect.left <= windowWidth) && ((rect.left + rect.width) >= 0);
 
 		return (vertInView && horInView);
 	} catch (e) {
Index: TXM/trunk/org.txm.setups/shared/win/txm.nsi
===================================================================
--- TXM/trunk/org.txm.setups/shared/win/txm.nsi	(revision 3421)
+++ TXM/trunk/org.txm.setups/shared/win/txm.nsi	(revision 3422)
@@ -15,9 +15,9 @@
 
 OutFile "../TXM_TXMDATEVERSION_Win64_installer.exe"
 
-InstallDir "$PROGRAMFILES64\TXM${Version}"
+InstallDir "$LOCALAPPDATA\TXM${Version}"
 
-RequestExecutionLevel admin
+;RequestExecutionLevel admin
 
 ;compression
 
Index: TXM/trunk/org.txm.xmleditor.rcp/src/org/txm/xmleditor/OpenXMLEditor.java
===================================================================
--- TXM/trunk/org.txm.xmleditor.rcp/src/org/txm/xmleditor/OpenXMLEditor.java	(revision 3421)
+++ TXM/trunk/org.txm.xmleditor.rcp/src/org/txm/xmleditor/OpenXMLEditor.java	(revision 3422)
@@ -12,6 +12,7 @@
 import org.eclipse.core.runtime.CoreException;
 import org.eclipse.core.runtime.FileLocator;
 import org.eclipse.core.runtime.Path;
+import org.eclipse.jface.dialogs.MessageDialog;
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
 import org.eclipse.search.ui.ISearchQuery;
@@ -47,6 +48,7 @@
 	
 	public static String lastopenedfile;
 	
+	public int ALERT = 1000;
 	
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
@@ -68,6 +70,12 @@
 			
 			File txmFile = text.getXMLTXMFile();
 			if (txmFile != null && txmFile.exists()) {
+				if (txmFile.length() > ALERT) {
+					if (!MessageDialog.openQuestion(shell, "Big file /o\\", txmFile.getAbsolutePath()+" is a very big file. Do you want to continue and opens it?")) {
+						Log.info("Aborting the opening of "+txmFile);
+						return null;
+					}
+				}
 				reditor = openfile(txmFile);
 			}
 			else { // wrong link ?
@@ -104,7 +112,7 @@
 				XMLMultiPageEditorPart xmlEditor = (XMLMultiPageEditorPart) reditor;
 				Object selectedPage = xmlEditor.getSelectedPage();
 				if (selectedPage != null && selectedPage instanceof StructuredTextEditor) {
-					System.out.println("Word selection: " + line.getKeywordIds());
+					System.out.println("Word selection identifiers: " + line.getKeywordIds());
 				}
 			}
 		}
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/function/WordPropertiestoTable.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/function/WordPropertiestoTable.java	(revision 0)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/function/WordPropertiestoTable.java	(revision 3422)
@@ -0,0 +1,25 @@
+package org.txm.rcp.commands.function;
+
+import java.io.File;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.ui.IWorkbenchPart;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.Toolbox;
+import org.txm.rcp.handlers.scripts.ExecuteGroovyMacro;
+
+public class WordPropertiestoTable extends AbstractHandler{
+
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		IWorkbenchPart part = HandlerUtil.getActivePart(event);
+		IStructuredSelection selection = HandlerUtil.getCurrentStructuredSelection(event);
+		
+		File script = new File(Toolbox.getTxmHomePath(), "/scripts/groovy/user/org/txm/macro/annotation/ExportWordPropertiesToTableMacro.groovy");
+		ExecuteGroovyMacro.execute(script.getAbsolutePath(), part, selection, "");
+		return null;
+	}
+}

